"use strict";
/** @license MIT License (c) copyright 2018 original author or authors */
/** @author Sergey Samokhov */
Object.defineProperty(exports, "__esModule", { value: true });
var scheduler_1 = require("@most/scheduler");
// fromEvent :: (Emitter emt, Event e) => String -> emt -> Stream e
var fromEvent = function (event, emitter) {
    return FromEvent(event, emitter, 'addListener');
};
exports.fromEvent = fromEvent;
var fromEventPrepended = function (event, emitter) {
    return FromEvent(event, emitter, 'prependListener');
};
exports.fromEventPrepended = fromEventPrepended;
function FromEvent(event, emitter, method) {
    return { run: run };
    function run(sink, scheduler) {
        emitter[method](event, send);
        return ListenerDisposable(emitter, event, send);
        function send(e) {
            tryEvent(scheduler_1.currentTime(scheduler), e, sink);
        }
    }
}
function ListenerDisposable(emitter, event, send) {
    return {
        dispose: function () {
            emitter.removeListener(event, send);
        }
    };
}
exports.ListenerDisposable = ListenerDisposable;
function tryEvent(t, e, sink) {
    try {
        sink.event(t, e);
    }
    catch (error) {
        sink.error(t, error);
    }
}
//# sourceMappingURL=index.js.map